const

  CH376_INT_SUCCESS    : Byte = $14;
  CH376_RET_SUCCESS    : Byte = $51;
  CH376_INT_DISK_READ  : Byte = $1D;
  CH376_INT_DISK_WRITE : Byte = $1E;



  // Fehlercode
  ERROR_CH376_not_connected     : Byte = 01;
  ERROR_USB_Stick_not_connected : Byte = 02;
  ERROR_FILE_OPEN               : Byte = 03;
  ERROR_wrong_file_size         : Byte = 04;
  ERROR_SET_USB_MODE            : Byte = 05;
  ERROR_DISK_CONNECT            : Byte = 06;
  ERROR_DISK_MOUNT              : Byte = 07;
  ERROR_FILE_CREATE             : Byte = 08;
  ERROR_FILE_CLOSE_WR           : Byte = 09;
  ERROR_FILE_CLOSE_RD           : Byte = 10;
  ERROR_BYTE_LOCATE             : Byte = 11;
  ERROR_BYTE_READ               : Byte = 12;
  ERROR_BYTE_RD_GO              : Byte = 13;
  ERROR_BYTE_WRITE              : Byte = 14;
  ERROR_BYTE_WRITE_Byte         : Byte = 15;
  ERROR_BYTE_WR_GO              : Byte = 16;
  ERROR_WR_REQ_DATA             : Byte = 17;



var
  Sektor_Array : Array [0..127] of Byte;
  Sektor_Array_Zeiger : Word;
  Datei_Zeiger, Datei_Groesse,
  Sektor_Nr, Spur_Nr : DWord;
  Read_oder_Write : Byte;
  Fehlercode : Byte;




procedure SER0_Zeichen_lesen;
begin

  SetBit(LED_Blau);
  while BitLow(RXC0) do
  endwhile;
  ClearBit(LED_Blau);

  SER0_Zeichen:=UDR0;

end SER0_Zeichen_lesen;





// Timeout-Zeit etwa 500mS
function SER0_Zeichen_lesen_Timeout : Boolean;
var
  Schleife_aktiv : Boolean;
  Schleife_Timeout : DWord;
begin

  Schleife_aktiv:=true;
  Schleife_Timeout:=0;

  SetBit(LED_Blau);

  while Schleife_aktiv do

    if BitHigh(RXC0) then
      Schleife_aktiv:=false;
    endif;

    Inc(Schleife_Timeout);

    if Schleife_Timeout>180000 then
      Schleife_aktiv:=false;
    endif;

  endwhile;

  ClearBit(LED_Blau);

  // Schleife_aktiv ist nun das Ergebnis
  // der Funktion

  if Schleife_Timeout>180000 then
    Schleife_aktiv:=false;
  else
    SER0_Zeichen:=UDR0;
    Schleife_aktiv:=true;
  endif;

  Result:=Schleife_aktiv;

end SER0_Zeichen_lesen_Timeout;







// *****************************************
// ******* Anzeigeroutinen an LED **********
// *****************************************



procedure Anzeige_des_Fehlercodes_an_LED;
var
  AFC : Byte;
begin

    // LEDs ausschalten
    ClearBit(LED_Gelb);
    ClearBit(LED_Gruen);
    ClearBit(LED_Rot);
    ClearBit(LED_Blau);

    for AFC:=1 to Fehlercode do

      wait_ms(400);

      // LEDs einschalten
      SetBit(LED_Gelb);
      SetBit(LED_Gruen);
      SetBit(LED_Rot);
      SetBit(LED_Blau);

      wait_ms(400);

      // LEDs ausschalten
      ClearBit(LED_Gelb);
      ClearBit(LED_Gruen);
      ClearBit(LED_Rot);
      ClearBit(LED_Blau);

    endfor;

    wait_ms(2000);

end Anzeige_des_Fehlercodes_an_LED;




procedure Anzeige_des_Fehlercodes;
begin

  if Fehlercode>0 then

    Anzeige_des_Fehlercodes_an_LED;
    Anzeige_des_Fehlercodes_an_LED;
    Anzeige_des_Fehlercodes_an_LED;

    Fehlercode:=0;

  endif;

end Anzeige_des_Fehlercodes;




// ************************************************
// ** Basis Prozeduren fuer Lesen und Schreiben ***
// ************************************************




// ok bei 25H -> DAH = FF - 25
procedure CH376B_CMD_CHECK_EXIST;
begin

  sende_Zeichen0($57);
 // wait_ms(5);
  sende_Zeichen0($AB);
 // wait_ms(5);
  sende_Zeichen0($06);
 // wait_ms(5);
  sende_Zeichen0($25);

  SER0_Zeichen_lesen;

  if SER0_Zeichen<>$DA then
      Fehlercode:=ERROR_USB_Stick_not_connected;
  endif;

end CH376B_CMD_CHECK_EXIST;




// GET_IC_VER
procedure CH376B_CMD_GET_IC_VER;
begin

  sende_Zeichen0($57);
  sende_Zeichen0($AB);
  sende_Zeichen0($01);

  SER0_Zeichen_lesen;

  if SER0_Zeichen<>$43 then
      Fehlercode:=ERROR_USB_Stick_not_connected;
  endif;

end CH376B_CMD_GET_IC_VER;





// RESET_ALL
procedure CH376B_CMD_RESET_ALL;
begin

  sende_Zeichen0($57);
  sende_Zeichen0($AB);
  sende_Zeichen0($05);

  wait_ms(200);

end CH376B_CMD_RESET_ALL;








// CMD_SET_BAUDRATE
procedure CH376B_CMD_SET_BAUDRATE;
begin

  sende_Zeichen0($57);
  sende_Zeichen0($AB);
  sende_Zeichen0($02);

  // 9.600 - Standard
 { sende_Zeichen0($02);
  sende_Zeichen0($B2);
  UBRR_VAL_VAR:=UBRR_VAL;
  INIT_SER0_PORT; }



  // 500.000
  sende_Zeichen0($03);
  sende_Zeichen0(244);
  wait_ms(5);
  UBRR_VAL_VAR:=1;
  INIT_SER0_PORT;


end CH376B_CMD_SET_BAUDRATE;








// SET_USB_MODE
procedure CH376B_CMD_SET_USB_MODE;
var
  Zeichen_gelesen : Boolean;
begin

  sende_Zeichen0($57);
  sende_Zeichen0($AB);
  sende_Zeichen0($15);
  sende_Zeichen0($06);

  wait_ms(5);

  SER0_Zeichen_lesen;

  wait_ms(5);

  if SER0_Zeichen=CH376_RET_SUCCESS then

  wait_ms(5);

    Zeichen_gelesen:=SER0_Zeichen_lesen_Timeout;

    if Zeichen_gelesen then

      if SER0_Zeichen<>$15 then
        Fehlercode:=ERROR_SET_USB_MODE;
      endif;

    else

      Fehlercode:=ERROR_USB_Stick_not_connected;
      Anzeige_des_Fehlercodes;

    endif;

  else

  //  Fehlercode:=ERROR_SET_USB_MODE;

  Zeichen_gelesen:=SER0_Zeichen_lesen_Timeout;

  endif;

end CH376B_CMD_SET_USB_MODE;









// DISK_CONNECT
procedure CH376B_CMD_DISK_CONNECT;
begin

  sende_Zeichen0($57);
  sende_Zeichen0($AB);
  sende_Zeichen0($30);

  SER0_Zeichen_lesen;

  if SER0_Zeichen<>CH376_INT_SUCCESS then
    Fehlercode:=ERROR_DISK_CONNECT;
    Anzeige_des_Fehlercodes;
  endif;

end CH376B_CMD_DISK_CONNECT;





// DISK_MOUNT
procedure CH376B_CMD_DISK_MOUNT;
begin

  sende_Zeichen0($57);
  sende_Zeichen0($AB);
  sende_Zeichen0($31);

  SER0_Zeichen_lesen;

  if SER0_Zeichen<>CH376_INT_SUCCESS then
    Fehlercode:=ERROR_DISK_MOUNT;
    Anzeige_des_Fehlercodes;
  endif;

end CH376B_CMD_DISK_MOUNT;





// ************************************************




// SET_FILE_NAME
procedure CH376B_CMD_SET_FILE_NAME;
begin

  sende_Zeichen0($57);
  sende_Zeichen0($AB);
  sende_Zeichen0($2F);

  sende_Zeichen0($2F);  // /
  Write_SER0;
  sende_Zeichen0($00);  // 0

  wait_ms(20);

end CH376B_CMD_SET_FILE_NAME;





// FILE_CREATE
procedure CH376B_CMD_FILE_CREATE;
begin

  sende_Zeichen0($57);
  sende_Zeichen0($AB);
  sende_Zeichen0($34);

  SER0_Zeichen_lesen;

  if SER0_Zeichen<>CH376_INT_SUCCESS then
    Fehlercode:=ERROR_FILE_CREATE;
  endif;

end CH376B_CMD_FILE_CREATE;





// FILE_OPEN
procedure CH376B_CMD_FILE_OPEN;
begin

  sende_Zeichen0($57);
  sende_Zeichen0($AB);
  sende_Zeichen0($32);

  SER0_Zeichen_lesen;

  if SER0_Zeichen<>CH376_INT_SUCCESS then
    Fehlercode:=ERROR_FILE_OPEN;
    Anzeige_des_Fehlercodes;
  endif;

end CH376B_CMD_FILE_OPEN;





// FILE_CLOSE_WR
procedure CH376B_CMD_FILE_CLOSE_WR;
begin

  sende_Zeichen0($57);
  sende_Zeichen0($AB);
  sende_Zeichen0($36);
  sende_Zeichen0($01);

  SER0_Zeichen_lesen;

  if SER0_Zeichen<>CH376_INT_SUCCESS then
    Fehlercode:=ERROR_FILE_CLOSE_WR;
  endif;

end CH376B_CMD_FILE_CLOSE_WR;





// FILE_CLOSE_RD
procedure CH376B_CMD_FILE_CLOSE_RD;
begin

  sende_Zeichen0($57);
  sende_Zeichen0($AB);
  sende_Zeichen0($36);
  sende_Zeichen0($00);

  SER0_Zeichen_lesen;

  if SER0_Zeichen<>CH376_INT_SUCCESS then
    Fehlercode:=ERROR_FILE_CLOSE_RD;
  endif;

end CH376B_CMD_FILE_CLOSE_RD;




// GET_FILE_SIZE
procedure CH376B_CMD_GET_FILE_SIZE;
var
  b1 : Byte;
  w1 : Word;
  w2 : Word;
  d1 : DWord;
begin

  sende_Zeichen0($57);
  sende_Zeichen0($AB);
  sende_Zeichen0($0C);
  sende_Zeichen0($68);


  SER0_Zeichen_lesen;
  b1:=SER0_Zeichen;

  w1:=ByteToWord(b1);

  SER0_Zeichen_lesen;
  b1:=SER0_Zeichen;

  w2:=ByteToWord(b1);
  w2:=w2*$100;
  w1:=w1+w2;

  d1:=WordToDWord(w1);

  SER0_Zeichen_lesen;
  b1:=SER0_Zeichen;

  w1:=ByteToWord(b1);

  SER0_Zeichen_lesen;
  b1:=SER0_Zeichen;

  w2:=ByteToWord(b1);
  w2:=w2*$100;
  w1:=w1+w2;

  Datei_Groesse:=WordToDWord(w1);
  Datei_Groesse:=Datei_Groesse*$100;
  Datei_Groesse:=Datei_Groesse*$100;
  Datei_Groesse:=Datei_Groesse+d1;

end CH376B_CMD_GET_FILE_SIZE;




// *****************************************
// **********   READ   *********************
// *****************************************





// BYTE_LOCATE
// setzen des Datei-Zeigers
procedure CH376B_CMD_BYTE_LOCATE;
var
  b1 : Byte;
begin

  sende_Zeichen0($57);
  sende_Zeichen0($AB);
  sende_Zeichen0($39);

  b1:=DWordToByte(0,Datei_Zeiger);
  sende_Zeichen0(b1);

  b1:=DWordToByte(1,Datei_Zeiger);
  sende_Zeichen0(b1);

  b1:=DWordToByte(2,Datei_Zeiger);
  sende_Zeichen0(b1);

  b1:=DWordToByte(3,Datei_Zeiger);
  sende_Zeichen0(b1);

  SER0_Zeichen_lesen;

  if SER0_Zeichen<>CH376_INT_SUCCESS then
    Fehlercode:=ERROR_BYTE_LOCATE;
  endif;

end CH376B_CMD_BYTE_LOCATE;






// CMD_BYTE_READ
// Festlegen der Anzahl der zu lesenden Bytes
procedure CH376B_CMD_BYTE_READ(Anzahl : Byte);
begin

  sende_Zeichen0($57);
  sende_Zeichen0($AB);
  sende_Zeichen0($3A);
  sende_Zeichen0(Anzahl);
  sende_Zeichen0($00);

  SER0_Zeichen_lesen;

  if SER0_Zeichen<>CH376_INT_DISK_READ then
    Fehlercode:=ERROR_BYTE_READ;
  endif;

end CH376B_CMD_BYTE_READ;





// RD_USB_DATA0
// Lesen der festgelegten Bytes
procedure CH376B_CMD_RD_USB_DATA0;
var
  RD_Anzahl  : Byte;
  RD_Zaehler : Byte;
begin

  sende_Zeichen0($57);
  sende_Zeichen0($AB);
  sende_Zeichen0($27);

  SER0_Zeichen_lesen;

  RD_Anzahl:=SER0_Zeichen;

  for RD_Zaehler:=1 to RD_Anzahl do
    SER0_Zeichen_lesen;
    Sektor_Array[Sektor_Array_Zeiger]:=SER0_Zeichen;
    Inc(Sektor_Array_Zeiger);
  endfor;

end CH376B_CMD_RD_USB_DATA0;





// CMD_BYTE_RD_GO - continueRead
procedure CH376B_CMD_BYTE_RD_GO;
begin

  sende_Zeichen0($57);
  sende_Zeichen0($AB);
  sende_Zeichen0($3B);

  SER0_Zeichen_lesen;

  if SER0_Zeichen<>CH376_INT_SUCCESS then
    Fehlercode:=ERROR_BYTE_RD_GO;
  endif;

end CH376B_CMD_BYTE_RD_GO;






// Lese_einen_Sektor
procedure Lese_einen_Sektor;
var
  b1 : Byte;
begin

  Sektor_Array_Zeiger:=0;

  CH376B_CMD_BYTE_LOCATE;

  for b1:=1 to 4 do

    CH376B_CMD_BYTE_READ(32);
    CH376B_CMD_RD_USB_DATA0;

  endfor;

  CH376B_CMD_BYTE_RD_GO;

end Lese_einen_Sektor;






// *****************************************
// *********   WRITE   *********************
// *****************************************



// BYTE_WRITE
procedure CH376B_CMD_BYTE_WRITE(Anzahl : Byte);
begin

  sende_Zeichen0($57);
  sende_Zeichen0($AB);
  sende_Zeichen0($3C);
  sende_Zeichen0(Anzahl);
  sende_Zeichen0($00);

  SER0_Zeichen_lesen;

  if SER0_Zeichen<>CH376_INT_DISK_WRITE then
    Fehlercode:=ERROR_BYTE_WRITE;
  endif;

end CH376B_CMD_BYTE_WRITE;







// BYTE_WR_GO
procedure CH376B_CMD_BYTE_WR_GO;
begin

  sende_Zeichen0($57);
  sende_Zeichen0($AB);
  sende_Zeichen0($3D);

  SER0_Zeichen_lesen;

  if SER0_Zeichen<>CH376_INT_SUCCESS then
    Fehlercode:=ERROR_BYTE_WR_GO;
  endif;

end CH376B_CMD_BYTE_WR_GO;







// CH376B_CMD_WR_REQ_DATA
procedure CH376B_CMD_WR_REQ_DATA(Anzahl : Byte);
var
  WR_Zaehler : Byte;
  WR_Byte : Byte;
begin

  sende_Zeichen0($57);
  sende_Zeichen0($AB);
  sende_Zeichen0($2D);

  for WR_Zaehler:=1 to Anzahl do
    WR_Byte:=Sektor_Array[Sektor_Array_Zeiger];
    sende_Zeichen0(WR_Byte);
    Inc(Sektor_Array_Zeiger);
  endfor;

  SER0_Zeichen_lesen;

  // CH376 gibt die Anzahl der
  // geschriebenen Bytes zurueck
  if SER0_Zeichen<>Anzahl then
    Fehlercode:=ERROR_WR_REQ_DATA;
  endif;

end CH376B_CMD_WR_REQ_DATA;










// Schreibe_einen_Sektor
procedure Schreibe_einen_Sektor;
var
  b1 : Byte;
  b2 : Byte;
  WR_Byte : Byte;
begin

  Sektor_Array_Zeiger:=0;

  CH376B_CMD_BYTE_LOCATE;

  for b1:=1 to 4 do

    CH376B_CMD_BYTE_WRITE(32);
    CH376B_CMD_WR_REQ_DATA(32);
    CH376B_CMD_BYTE_WR_GO;

  endfor;

end Schreibe_einen_Sektor;










// Berechnet aus Spur und Sektor
// die aktuelle Datei_Zeiger Position
procedure Spur_und_Sektor_in_Datei_Zeiger;
begin

  // Datei_Zeiger:=Spur_Nr*64;
  Datei_Zeiger:=Spur_Nr*128;
  Datei_Zeiger:=Datei_Zeiger+Sektor_Nr;
  Datei_Zeiger:=Datei_Zeiger*128;

end Spur_und_Sektor_in_Datei_Zeiger;








// *****************************************
// ********** Initialisierung **************
// *****************************************



// CH376B_Init
procedure CH376B_Init;
begin

  Fehlercode:=0;

  CH376B_CMD_RESET_ALL;

  CH376B_CMD_SET_BAUDRATE;

  CH376B_CMD_SET_USB_MODE;

  if Fehlercode=0 then

    CH376B_CMD_DISK_CONNECT;

    CH376B_CMD_DISK_MOUNT;

    SER0_String:='DRIVE.IMG';
    CH376B_CMD_SET_FILE_NAME;

    CH376B_CMD_FILE_OPEN;

    CH376B_CMD_GET_FILE_SIZE;

    // CH376B_Anzeige_Dateigroesse;

  else

    Anzeige_des_Fehlercodes;

  endif;

end CH376B_Init;














